' $INCLUDE: 'UTILS.BI'

FUNCTION GetDirFromPath (path AS STRING) AS STRING
    GetDirFromPath = ""
    DIM newPath AS STRING
    newPath = XREPLACE(path, GetDriveFromPath(path) + ":", "")
    newPath = XREPLACE(newPath, "\" + GetFileFromPath(path), "")
    GetDirFromPath = newPath
END FUNCTION

FUNCTION GetDriveFromPath (path AS STRING) AS STRING
    GetDriveFromPath = ""
    IF MID$(path, 2, 1) = ":" THEN
        GetDriveFromPath = LEFT$(path, 1)
    ELSE
        EXIT FUNCTION
    END IF
END FUNCTION

FUNCTION GetFileFromPath (path AS STRING) AS STRING
    GetFileFromPath = ""
    IF INSTR(path, "\") > 0 THEN
        DIM revPath AS STRING
        revPath = XREVERSE(path)
        GetFileFromPath = XREVERSE(LEFT$(revPath, INSTR(revPath, "\") - 1))
    END IF
END FUNCTION

FUNCTION XREPLACE (str AS STRING, find AS STRING, repl AS STRING) AS STRING
    DIM workingVal AS STRING
    workingVal = str
    IF INSTR(workingVal, find) > 0 THEN
        workingVal = LEFT$(workingVal, INSTR(workingVal, find) - 1) + repl + MID$(workingVal, INSTR(workingVal, find) + LEN(find) + 1)
        IF INSTR(workingVal, find) > 0 THEN
            workingVal = XREPLACE(workingVal, find, repl)
        END IF
    END IF
    XREPLACE = workingVal
END FUNCTION

FUNCTION XREVERSE (str AS STRING) AS STRING
    IF LEN(str) = 0 THEN
        XREVERSE = ""
        EXIT FUNCTION
    END IF
    DIM workingVal AS STRING
    workingVal = ""
    DIM i AS INTEGER
    FOR i = LEN(str) TO 1 STEP -1
        workingVal = workingVal + MID$(str, i, 1)
    NEXT
    XREVERSE = workingVal
END FUNCTION

